class Lab1 {

    task1(inputStr) {
        let charMap = {};
        const chars = inputStr.split("");
        chars.forEach(c => charMap[c.toLowerCase()] = (charMap[c.toLowerCase()] || 0) + 1);
        return chars.map(c => charMap[c.toLowerCase()] > 1 ? ")" : "(").join("");
    }

    task2(matrix) {
        function getSubpart(matrix, size, i, j) {
            const baseI = i * size;
            const baseJ = j * size;
            return Array.from({ length: size * size }, (_, index) => matrix[baseI + Math.floor(index / size)][baseJ + (index % size)])
        }

        function getSubparts(matrix) {
            const partSize = 3;
            const partsInRow = matrix.length / partSize;
            const partsTotal = partsInRow * partsInRow;
            return Array.from({ length: partsTotal }, (_, i) => getSubpart(matrix, partSize, Math.floor(i / partsInRow), i % partsInRow));
        }

        function isRowValid(set) {
            return options.every(o => set.some(re => re === o));
        }

        const options = [1, 2, 3, 4, 5, 6, 7, 8, 9];
        const rowsValid = matrix.every(isRowValid);

        const columns = Array.from({ length: matrix.length }, (_, i) =>
            Array.from({ length: matrix.length }, (_, j) => matrix[j][i]));
        const columnsValid = columns.every(isRowValid);

        const subParts = getSubparts(matrix);
        const subpartsValid = subParts.every(isRowValid);
        return rowsValid && columnsValid && subpartsValid;
    }
}

module.exports = Lab1;